#include "Header.h"


//    ( )
std::string in_poliz(std::string str) {

	std::stack<char> St;

	std::string res = "";
	std::string alpha = "abcdefghijklmnopqrstuvwxyz01";
	std::string left = "(";
	std::string right = ")";
	std::string oper = "+*";
	std::string prefix_oper = "!";

	for (char s : str) {

		//  ?
		if (alpha.find(s) != std::string::npos) {
			res = res + s + " ";
		}
		//   ?
		else if (left.find(s) != std::string::npos)
			St.push(s);

		//   ?
		else if (right.find(s) != std::string::npos) {
			while (!St.empty() && St.top() != '(') {
				res = res + St.top() + " ";
				St.pop();
			}
			St.pop();

		}
		//     
		else if (prefix_oper.find(s) != std::string::npos) {
			St.push(s);
		}
		//     
		else if (oper.find(s) != std::string::npos) {
			while (!St.empty() && oper.find(St.top()) != std::string::npos) {
				res = res + St.top() + " ";
				St.pop();
			}
			St.push(s);
		}
	}
	while (!St.empty()) {
		res = res + St.top() + " ";
		St.pop();
	}
	return res;
}


//     ( )
bool solve_poliz(std::string str) {
	
	std::stack<char> ST;

	int num1;							//   
	int num2;							//   
	int res;

	std::string number = "01";

	for (auto i = 0; i < str.length(); i++) {

		if (number.find(str[i]) != std::string::npos) {
			ST.push(atoi(&str.c_str()[i]));
		}
		else if (str[i] == ' ') {
		}

		else {
			

			switch (str[i]) {

			case '+': 
				num2 = ST.top();
				ST.pop();
				num1 = ST.top();
				ST.pop(); 
				res = (num1 || num2);
				break;
			case '*': 
				num2 = ST.top();
				ST.pop();
				num1 = ST.top();
				ST.pop(); 
				res = (num1 && num2); break;
			case '!':
				num1 = ST.top();
				ST.pop(); 
				if (num1 == 1) {
					res = 0; break;
				}
				else {
					res = 1; break;
				}
					
				
			default: std::cout << " !\n";

			}
			ST.push(res);
		}
	}

	return ST.top() - 0;
}

//    
int count_variable(std::string str) {
	
	std::string res = "";
	std::string alpha = "abcdefghijklmnopqrstuvwxyz";

	for (char s : str) {

		//   ?
		if (alpha.find(s) != std::string::npos && res.find(s) == std::string::npos){
			res = res + s;
		}
	}

	return res.length();
}

//   
void ProcessBinaryVector(std::vector<int> S, std::string str, int k, int n, bool &flag) {

	std::string new_str = str;

	if (!flag) {
		if (k > n) {
			new_str = str;
			//    vector S   new_str
			Process(S, new_str);
			//   S
			if (solve_poliz(new_str)) {
				flag = true;
			}
		}


		else {
			S[k] = 0;
			ProcessBinaryVector(S, str, k + 1, n, flag);
			S[k] = 1;
			ProcessBinaryVector(S, str, k + 1, n, flag);
		}
	}
}

//    0  1   
void Process(std::vector<int> S, std::string& new_str) {

	//  
	std::string alpha = "abcdefghijklmnopqrstuvwxyz";
	std::map<int, char> dict;
	int k = 0;
	int pos = 0;


	for (char a : alpha) {
		dict[k] = a;
		k++;
	}

	for (int i = 0; i < S.size(); i++) {
		
		pos = new_str.find(dict[i]);
		while (pos!= std::string::npos) {
			new_str.replace(pos, 1, std::to_string(S[i]));
			pos = new_str.find(dict[i]);
		}
	}
}

//   
std::string isExists(bool flag) {

	if (flag)
		return "Exists";
	else
		return "Not Exists";
}